Imports NorrisLabs.Interface.SmartArm

Public Class MainForm

    Private m_Arm As SmartArm

    Private m_PosBase As Integer
    Private m_PosElbow As Integer
    Private m_PosWrist As Integer
    Private m_PosWristRotate As Integer
    Private m_PosGrip As Integer

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_Arm = New SmartArm("COM13")
        If Not m_Arm Is Nothing Then
            UpdatePositions()
        End If

    End Sub

#Region "Click Events"

    Private Sub MainForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        m_Arm = Nothing
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        UpdatePositions()
    End Sub

    Private Sub btnLockAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockAll.Click
        m_Arm.LockAll(True)
        UpdatePositions()
    End Sub

    Private Sub btnUnlockAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockAll.Click
        m_Arm.LockAll(False)
    End Sub

    Private Sub btnHome_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHome.Click
        HomeArm()
        UpdatePositions()
    End Sub

#Region "Base Control Events"
    Private Sub btnCenterBase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCenterBase.Click

        Me.Cursor = Cursors.WaitCursor
        m_Arm.SetBase(511, 50, -1)
        UpdateBasePos()
        Me.Cursor = Cursors.Default

    End Sub

    Private Sub btnLeftBase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLeftBase.Click

        If m_PosBase + GetMovement() < 1024 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetBase(m_PosBase + GetMovement(), 50, -1)
            UpdateBasePos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnRightBase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRightBase.Click

        If m_PosBase - GetMovement() > 0 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetBase(m_PosBase - GetMovement(), 50, -1)
            UpdateBasePos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnLockBase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockBase.Click
        m_Arm.LockBase(True)
        UpdateBasePos()
    End Sub

    Private Sub btnUnlockBase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockBase.Click
        m_Arm.LockBase(False)
    End Sub
#End Region

#Region "Elbow Control Events"
    Private Sub btnCenterElbow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCenterElbow.Click

        Me.Cursor = Cursors.WaitCursor
        m_Arm.SetElbow(511, 50, -1)
        UpdateElbowPos()
        Me.Cursor = Cursors.Default

    End Sub

    Private Sub btnUpElbow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpElbow.Click

        If m_PosElbow + GetMovement() < 1024 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetElbow(m_PosElbow + GetMovement(), 50, -1)
            UpdateElbowPos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnDownElbow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDownElbow.Click

        If m_PosElbow - GetMovement() > 0 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetElbow(m_PosElbow - GetMovement(), 50, -1)
            UpdateElbowPos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnLockElbow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockElbow.Click
        m_Arm.LockElbow(True)
        UpdateElbowPos()
    End Sub

    Private Sub btnUnlockElbow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockElbow.Click
        m_Arm.LockElbow(False)
    End Sub
#End Region

#Region "Wrist Control Events"
    Private Sub btnCenterWrist_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCenterWrist.Click

        Me.Cursor = Cursors.WaitCursor
        m_Arm.SetWrist(511, 50, -1)
        UpdateWristPos()
        Me.Cursor = Cursors.Default

    End Sub

    Private Sub btnUpWrist_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpWrist.Click

        If m_PosWrist + GetMovement() < 1024 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetWrist(m_PosWrist + GetMovement(), 50, -1)
            UpdateWristPos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnDownWrist_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDownWrist.Click

        If m_PosWrist - GetMovement() > 0 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetWrist(m_PosWrist - GetMovement(), 50, -1)
            UpdateWristPos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnLockWrist_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockWrist.Click
        m_Arm.LockWrist(True)
        UpdateWristPos()
    End Sub

    Private Sub btnUnlockWrist_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockWrist.Click
        m_Arm.LockWrist(False)
    End Sub
#End Region

#Region "Wrist Rotate Control Events"
    Private Sub btnCenterWRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCenterWRotate.Click

        Me.Cursor = Cursors.WaitCursor
        m_Arm.SetWristRotate(511, 50, -1)
        UpdateWristRotatePos()
        Me.Cursor = Cursors.Default

    End Sub

    Private Sub btnLeftWRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLeftWRotate.Click

        If m_PosWristRotate + GetMovement() < 1024 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetWristRotate(m_PosWristRotate + GetMovement(), 50, -1)
            UpdateWristRotatePos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnRightWRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRightWRotate.Click

        If m_PosWristRotate - GetMovement() > 0 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetWristRotate(m_PosWristRotate - GetMovement(), 50, -1)
            UpdateWristRotatePos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnLockWRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockWRotate.Click
        m_Arm.LockWristRotate(True)
        UpdateWristRotatePos()
    End Sub

    Private Sub btnUnlockWRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockWRotate.Click
        m_Arm.LockWristRotate(False)
    End Sub
#End Region

#Region "Gripper Control Events"
    Private Sub btnCenterGrip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCenterGrip.Click

        Me.Cursor = Cursors.WaitCursor
        m_Arm.SetGripper(511, 50, -1)
        UpdateGripPos()
        Me.Cursor = Cursors.Default

    End Sub

    Private Sub btnOpenGrip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenGrip.Click

        If m_PosGrip - GetMovement() > 511 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetGripper(m_PosGrip - GetMovement(), 50, -1)
            UpdateGripPos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnCloseGrip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCloseGrip.Click

        If m_PosGrip + GetMovement() < 750 Then
            Me.Cursor = Cursors.WaitCursor
            m_Arm.SetGripper(m_PosGrip + GetMovement(), 50, -1)
            UpdateGripPos()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub btnLockGrip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockGrip.Click
        m_Arm.LockGripper(True)
        UpdateGripPos()
    End Sub

    Private Sub btnUnlockGrip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockGrip.Click
        m_Arm.LockGripper(False)
    End Sub
#End Region

#End Region

#Region "Helper Functions"

    Private Sub HomeArm()

        m_Arm.SetGripper(511, 50)
        m_Arm.SetWrist(190, 50, 0)
        m_Arm.SetWristRotate(511, 50, 0)
        m_Arm.SetBase(511, 50, 0)
        m_Arm.SetElbow(767, 50, -1)

    End Sub

    Private Sub UpdatePositions()

        UpdateBasePos()
        UpdateElbowPos()
        UpdateWristPos()
        UpdateWristRotatePos()
        UpdateGripPos()

    End Sub

    Private Sub UpdateBasePos()

        m_PosBase = m_Arm.GetBasePosition
        txtPosBase.Text = m_PosBase.ToString

    End Sub

    Private Sub UpdateElbowPos()

        m_PosElbow = m_Arm.GetElbowPosition
        txtPosElbow.Text = m_PosElbow.ToString

    End Sub

    Private Sub UpdateWristPos()

        m_PosWrist = m_Arm.GetWristPosition
        txtPosWrist.Text = m_PosWrist.ToString

    End Sub

    Private Sub UpdateWristRotatePos()

        m_PosWristRotate = m_Arm.GetWristRotatePosition
        txtPosWRotate.Text = m_PosWristRotate.ToString

    End Sub

    Private Sub UpdateGripPos()

        m_PosGrip = m_Arm.GetGripperPosition
        txtPosGrip.Text = m_PosGrip.ToString

    End Sub

    Private Function GetMovement() As Integer

        If rbFine.Checked Then
            Return 5
        ElseIf rbMedium.Checked Then
            Return 10
        Else
            Return 30
        End If

    End Function

#End Region

End Class
